'Compilable Example:
#Compile Exe "gbjournal.exe"
#Dim All
#Debug Error On
#Debug Display On
#Include "Win32API.inc"
#Include "RichEdit.inc"
#Include "CommCtrl.inc"

#Resource Icon, aaa, "images\gbjournal.ico"
#Resource Icon, xCreate, "images\create.ico"
#Resource Icon, xFonts, "images\text.ico"
#Resource Icon, xHelp, "images\help.ico"
#Resource Icon, xSize, "images\width.ico"
#Resource Icon, xColors, "images\colors.ico"
#Resource Icon, xView, "images\view.ico"
#Resource Icon, xSettings, "images\settings.ico"
#Resource Icon, xSave, "images\saveb.ico"
#Resource Icon, xOpen, "images\open.ico"
#Resource Icon, xNew, "images\new.ico"
#Resource Icon, xWords, "images\words.ico"
#Resource Icon, xImage, "images\image.ico"
#Resource Icon, xPatterns, "images\patterns.ico"
#Resource Icon, xLock, "images\lock.ico"
#Resource Icon, xPrevious, "images\previous.ico"
#Resource Icon, xNext, "images\next.ico"
#Resource Icon, xDelete, "images\delete.ico"
#Resource Icon, xEncrypt, "images\key.ico"
#Resource Icon, xNewDate, "images\calendar.ico"
#Resource Icon, xSettings, "images\settings.ico"
#Resource Icon, xSearch, "images\search.ico"

Type Blog
    date As String * 20
    author As String * 20
    key As String * 20
    words As String * 1000
End Type

Type CustomColors
   c(15) As Long
End Type

$Ver = " 1.0 "
$Delimiter = ":::"

%IDC_RichEdit   = 500
%IDC_Toolbar    = 501
%IDC_Calendar   = 502
%IDC_ListBox    = 503
%IDC_Label      = 504

%IDC_SearchTerm     = 550
%IDC_SearchPrevious = 551
%IDC_SearchNext     = 552
%IDC_SearchLabel    = 553

%IDT_NewJournal = 600
%IDT_Delete     = 601
%IDT_Next       = 602
%IDT_Previous   = 603
%IDT_Open       = 604
%IDT_Save       = 605
%IDT_Help       = 606
%IDT_NewBlog    = 607
%IDT_Settings   = 608
%IDT_Encrypt    = 609
%IDT_Search     = 610

%IDC_Date       = 700
%IDC_Author     = 701
%IDC_Key        = 702
%IDC_Words      = 703

%IDM_SaveAs         = 800
%IDM_About          = 801
%IDM_SortAscending  = 802
%IDM_SortDescending = 803
%IDM_SelectDate     = 804
%IDM_ConfirmDelete  = 805
%IDM_AutoSave       = 806
%IDM_Sep            = 807

%IDM_CutDate        = 901
%IDM_CopyDate       = 902
%IDM_PasteDate      = 903
%IDM_DeleteDate     = 904
%IDM_CutAuthor      = 905
%IDM_CopyAuthor     = 906
%IDM_PasteAuthor    = 907
%IDM_DeleteAuthor   = 908
%IDM_CutKey         = 909
%IDM_CopyKey        = 910
%IDM_PasteKey       = 911
%IDM_DeleteKey      = 912
%IDM_CutWords       = 913
%IDM_CopyWords      = 914
%IDM_PasteWords     = 915
%IDM_DeleteWords    = 916
%IDM_Debug          = 917
%IDM_ClearConsole   = 918
%IDM_LabelColor     = 919
%IDM_Search         = 920

Global hDlg,hToolbar,hRichEdit,hImageList,hCalDialog,hCalendar,hConsole,hSearch As Dword
Global OldProcDate, OldProcAuthor, OldProcKey, OldProcWords, Debug As Long, hDate,hAuthor,hKey,hWords As Dword
Global hContextKey, hContextAuthor, hContextDate, hContextWords As Dword, CustomColorList As CustomColors
Global hHook,hPopupSave,hPopupSettings,hPopupHelp,hPopupDate,hFontLabel,hFontHeader,hFontBlog As Dword
Global W() As Blog, DT As SystemTime, psw As String, LabelColor As Long, CFN, CalendarDate,SearchTerm As String
Global maxBlogs, curBlog, ConfirmDelete, Encrypt, AutoSave, Changes, OneOnly, NewJournalCount,fDlgShown,SearchStart As Long

Function PBMain() As Long
   If InstanceTest = 0 Then MsgBox "Previous instance detected. Only one instance allowed!", %MB_Ok + %MB_IconExclamation, "gbJournal" : Exit Function
   Local style&
   Dialog New Pixels, 0, "gbJournal",300,300,400,300, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "aaa"
   CreateFonts
   Control Add Label, hDlg, %IDC_Label,Date$,0,50,300,30, %SS_CenterImage Or %SS_Center Or %WS_Border
   Control Set Font hDlg, %IDC_Label, hFontLabel
   Control Set Color hDlg, %IDC_Label, %Black, %rgb_LightBlue
   CreateImageList
   CreateToolbar
   Control Add ListBox, hDlg, %IDC_ListBox, , 10,85,90,100, %LBS_Notify Or %WS_TabStop Or %WS_VScroll Or %LBS_NoIntegralHeight, %WS_Ex_ClientEdge
   Control Add TextBox, hDlg, %IDC_Date,"Date", 110,95,120,20
   Control Add TextBox, hDlg, %IDC_Author,"Author", 110,125,120,20
   Control Add TextBox, hDlg, %IDC_Key,"Key", 110,155,120,20
   style& = %WS_TabStop Or %WS_Border Or  %ES_Left Or %ES_AutoHScroll Or %ES_MultiLine Or %ES_NoHideSel Or %ES_WantReturn
   Control Add TextBox, hDlg, %IDC_Words,"Blog", 240,85,190,155, style&, %WS_Ex_ClientEdge
   CreateRichEditControl
   Dialog Show Modal hDlg Call DlgProc
End Function

Sub CreateRichEditControl
    If Debug Then cPrint LCase$(FuncName$)
   Local style&, buf$
   buf$ =  "This is sample" + $CrLf + "text for the" + $CrLf + "RichEdit control."
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
             Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %ES_NoHideSel Or %ES_ReadOnly  '%WS_TabStop Or %ES_ReadOnly
    LoadLibrary("riched32.dll") : InitCommonControls
    Control Add "RichEdit", hDlg, %IDC_RichEdit, buf$, 10, 190, 200, 300, style&, %WS_Ex_ClientEdge
    Control Handle hDlg, %IDC_RichEdit To hRichEdit
    SendMessage hRichEdit, %EM_SETEVENTMASK, 0, %ENM_SELCHANGE Or %ENM_CHANGE Or %ENM_LINK
    SendMessage hRichEdit, %EM_SETLIMITTEXT, &H100000&, 0
'    SendMessage hRichEdit, %EM_SetReadOnly, 0,0
End Sub

CallBack Function DlgProc() As Long
   Local P As CharRange, iResult,ww,hh As Long, nmtb As TBNotify Ptr, rc As Rect, temp$
   Select Case Cb.Msg
       Case %WM_InitDialog
           BuildAcceleratorTable
           SubClassControls
           Settings_INI "get"
           Control Set Color hDlg, %IDC_Label, %Black, LabelColor
           If IsFalse(IsFile(Trim$(CFN))) Then CFN = CreateNewJournal
           If ValidatePassword(CFN) Then LoadCFN
           curBlog = UBound(W)
           ShowAllBlogs
           ShowBlog(curBlog)
           'unselect all in RE
           iResult = SendMessage(hRichEdit, %EM_EXGetSel, 0, VarPtr(P))
           P.cpmax = P.cpmin
           iResult = SendMessage(hRichEdit, %EM_EXSetSel, 0, VarPtr(P))    'P.cpmin = P.cpmax unselects all
           SetFocus hRichEdit

       Case %WM_Command
           Select Case Cb.Ctl
               Case %IDC_Date
                  If Cb.CtlMsg = %EN_Change Then
                     Control Get Text hDlg, %IDC_Date To temp$
                     Control Set Text hDlg, %IDC_Label, temp$
                  End If

               Case %IDT_NewJournal
                   If Changes Then
                      Select Case MsgBox("Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "New")
                         Case %IdYes
                             'save
                             SaveBlogs
                             CFN = CreateNewJournal
                             LoadCFN : curBlog = UBound(W) : ShowAllBlogs : ShowBlog(curBlog)
                         Case %IdNo
                             'no save
                             CFN = CreateNewJournal
                             LoadCFN : curBlog = UBound(W) : ShowAllBlogs : ShowBlog(curBlog)
                         Case %IdCancel
                             'no action
                      End Select
                   Else
                      CFN = CreateNewJournal
                      LoadCFN : curBlog = UBound(W) : ShowAllBlogs : ShowBlog(curBlog)
                   End If
               Case %IDT_Open
                   If Changes Then
                      Select Case MsgBox("Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Open")
                         Case %IdYes
                             'save
                             SaveBlogs
                             If SelectCFN Then LoadCFN : curBlog = UBound(W) : ShowAllBlogs : ShowBlog(curBlog)
                         Case %IdNo
                             'no save
                             If SelectCFN Then LoadCFN : curBlog = UBound(W) : ShowAllBlogs : ShowBlog(curBlog)
                         Case %IdCancel
                             'no action
                      End Select
                   Else
                      If SelectCFN Then LoadCFN : curBlog = UBound(W) : ShowAllBlogs : ShowBlog(curBlog)
                   End If
               Case %IDT_Save
                  SaveBlogs
                  Changes = 0
               Case %IDT_NewBlog 'toda
                  UpdateCurrentBlog
                  Control Get Text hDlg, %IDC_Author To temp$
                  Incr maxBlogs
                  curBlog = maxBlogs
                  ReDim Preserve W(maxBlogs)
                  W(curBlog).date = Date$
                  W(curBlog).author = temp$
                  W(curBlog).key = "<empty>"
                  W(curBlog).words = "<empty>"
                  ShowBlog(curBlog)
                  ShowAllBlogs
                  Changes = 1
               Case %IDM_SelectDate
                  ShowCalendarDialog
                  If Len(CalendarDate) Then
                      UpdateCurrentBlog
                      Control Get Text hDlg, %IDC_Author To temp$
                      Incr maxBlogs
                      curBlog = maxBlogs
                      ReDim Preserve W(maxBlogs)
                      W(curBlog).date = CalendarDate
                      W(curBlog).author = temp$
                      W(curBlog).key = "<empty>"
                      W(curBlog).words = "<empty>"
                      ShowBlog(curBlog)
                      ShowAllBlogs
                      Changes = 1
                  End If

               Case %IDT_Delete
                  If maxBlogs = 1 Then
                      Beep
                  Else
                      If ConfirmDelete Then
                          Select Case MsgBoxX("Delete Selected Date?", %MB_OkCancel + %MB_IconQuestion, "Delete")
                              Case %IdOk : DeleteCurrentBlog
                          End Select
                      Else
                          DeleteCurrentBlog
                      End If
                  End If
               Case %IDT_Next
                   If curBlog = UBound(W) Then
                       Beep
                   Else
                       UpdateCurrentBlog
                       Incr curBlog
                       ShowBlog(curBlog)
                       ListBox Select hDlg, %IDC_ListBox, UBound(W) - curBlog + 1
                   End If
               Case %IDT_Previous
                   If curBlog = 1 Then
                       Beep
                   Else
                      UpdateCurrentBlog
                      Decr curBlog
                      ShowBlog(curBlog)
                      ListBox Select hDlg, %IDC_ListBox, UBound(W) - curBlog + 1
                   End If

               Case %IDM_AutoSave
                   AutoSave = AutoSave Xor 1
                   Menu Set State hPopupSettings, ByCmd %IDM_AutoSave, AutoSave * 8
               Case %IDM_ConfirmDelete
                   ConfirmDelete = ConfirmDelete Xor 1
                   Menu Set State hPopupSettings, ByCmd %IDM_ConfirmDelete, ConfirmDelete * 8
               Case %IDT_Encrypt
                   Encrypt = Encrypt Xor 1
               Case %IDT_Search : DisplayFindDialog
               Case %IDT_Help
                   temp$ = "http://www.garybeene.com/sw/gbjournal.htm"
                   iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

               Case %IDC_ListBox
                   Select Case Cb.CtlMsg
                       Case %LBN_SelChange
                           ListBox Get Select hDlg, %IDC_ListBox To iResult
                           curBlog = UBound(W) - iResult + 1
                           ShowBlog(curBlog)
                   End Select
               Case %IDM_SaveAs
                   If SaveAs Then SaveBlogs : Dialog Set Text hDlg, "gbJournal" + $ver + Space$(5) + CFN
               Case %IDM_SortAscending
                   SortAscending
                   ShowAllBlogs
               Case %IDM_SortDescending
                   SortDescending
                   ShowAllBlogs
               Case %IDM_About
                   MsgBoxX("gbJournal" + $ver, %MB_Ok + %MB_IconInformation, "About")

            Case %IDM_CutWords    : SendMessage hWords, %WM_CUT, 0, 0
            Case %IDM_CopyWords   : SendMessage hWords, %WM_COPY, 0, 0
            Case %IDM_PasteWords  : SendMessage hWords, %WM_PASTE, 0, 0
            Case %IDM_DeleteWords : SendMessage hWords, %WM_CLEAR, 0, 0

            Case %IDM_CutDate    : SendMessage hDate, %WM_CUT, 0, 0
            Case %IDM_CopyDate   : SendMessage hDate, %WM_COPY, 0, 0
            Case %IDM_PasteDate  : SendMessage hDate, %WM_PASTE, 0, 0
            Case %IDM_DeleteDate : SendMessage hDate, %WM_CLEAR, 0, 0

            Case %IDM_CutAuthor    : SendMessage hAuthor, %WM_CUT, 0, 0
            Case %IDM_CopyAuthor   : SendMessage hAuthor, %WM_COPY, 0, 0
            Case %IDM_PasteAuthor  : SendMessage hAuthor, %WM_PASTE, 0, 0
            Case %IDM_DeleteAuthor : SendMessage hAuthor, %WM_CLEAR, 0, 0

            Case %IDM_CutKey    : SendMessage hKey, %WM_CUT, 0, 0
            Case %IDM_CopyKey   : SendMessage hKey, %WM_COPY, 0, 0
            Case %IDM_PasteKey  : SendMessage hKey, %WM_PASTE, 0, 0
            Case %IDM_DeleteKey : SendMessage hKey, %WM_CLEAR, 0, 0

            Case %IDM_Debug
               Debug = Debug Xor 1
               If Debug Then
                  cPrint "Console Display Enabled" + $CrLf + String$(30,"=")
               Else
                  FreeConsole
                  hConsole = 0
               End If
            Case %IDM_ClearConsole : ClearConsole

            Case %IDM_LabelColor
                LabelColor = SelectColor(LabelColor)
                Control Set Color hDlg, %IDC_Label, %Black, LabelColor
                Control ReDraw hDlg, %IDC_Label

            Case %IDM_Search : DisplayFindDialog
           End Select

      Case %WM_Notify
          nmtb = Cb.LParam
          Select Case @nmtb.hdr.Code
             Case %TBN_DROPDOWN
                Select Case @nmtb.iItem
                   Case %IDT_Save
                      Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                      Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                      Call TrackPopupMenu (hPopUpSave, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                   Case %IDT_Settings
                      Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                      Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                      Call TrackPopupMenu (hPopUpSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                   Case %IDT_NewBlog
                      Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                      Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                      Call TrackPopupMenu (hPopUpDate, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                   Case %IDT_Help
                      Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                      Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                      Call TrackPopupMenu (hPopUpHelp, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                End Select
          End Select

      Case %WM_Size
         Dialog Get Client hDlg To ww,hh
         Control Set Size hDlg, %IDC_Label, ww, 30
         Control ReDraw hDlg, %IDC_Label
         Control Set Size hDlg, %IDC_RichEdit, ww-20, hh-200
         Control Set Size hDlg, %IDC_Words, ww-250, 100

      Case %WM_SYSCOMMAND
         If Changes And AutoSave Then
             UpdateCurrentBlog
             SaveBlogs
         Else
             If Changes And ((Cb.WParam And &HFFF0) = %SC_Close) Then    'trap Alt-F4, X-button, WindowMenu/Close
                Select Case MsgBox("Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Exit gbJournal")
                   Case %IdYes
                       UpdateCurrentBlog
                       SaveBlogs
                   Case %IdNo
                       'no save
                   Case %IdCancel
                      Function = 1   'True - abort the close - no further processing needed
                End Select
             End If
         End If
      Case %WM_Destroy
         Settings_INI "save"
         SetWindowLong hDate, %GWL_WNDPROC, OldProcDate   'un-subclass
         SetWindowLong hAuthor, %GWL_WNDPROC, OldProcAuthor   'un-subclass
         SetWindowLong hKey, %GWL_WNDPROC, OldProcKey   'un-subclass
         SetWindowLong hWords, %GWL_WNDPROC, OldProcWords   'un-subclass
   End Select
End Function

Sub LoadCFN
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$
    MaxBlogs = 0
    Open CFN For Input As #1
    Line Input #1, temp$   'encrypted or not
    Line Input #1, temp$   'validation string for encryption
    While IsFalse(Eof(1))
        Line Input #1, temp$
        If Left$(temp$,3) = $DeLimiter Then
            'get header
            Incr MaxBlogs
            ReDim Preserve W(MaxBlogs)
            W(MaxBlogs).date = Parse$(temp$,$Delimiter,2)
            W(MaxBlogs).author = Parse$(temp$,$Delimiter,3)
            W(MaxBlogs).key = Parse$(temp$,$Delimiter,4)
            Line Input #1, W(MaxBlogs).words
        Else
            W(MaxBlogs).words = Trim$(W(MaxBlogs).words) + $CrLf + temp$
        End If
    Wend
    Close #1
    Dialog Set Text hDlg, "gbJournal" + $ver + Space$(5) + CFN
    Changes = 0
End Sub

Sub SaveBlogs
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long, temp$
    If Encrypt Then
        temp$ = EnterPassword
        If Len(temp$) Then
            psw = temp$
            Open CFN For Output As #1
            Print #1, "1"
            Print #1, EncryptData("Success",psw)
            For i = 1 To UBound(W)
                Print #1, $Delimiter + EncryptData(Trim$(W(i).date),psw) + _
                          $Delimiter + EncryptData(Trim$(W(i).Author),psw) + _
                          $Delimiter + EncryptData(Trim$(W(i).Key),psw) + $Delimiter
                Print #1, EncryptData(Trim$(W(i).words),psw)
            Next i
            Close #1
        Else
            MsgBoxX "No password entered. Journal not saved!", %MB_Ok + %MB_IconExclamation, "Save Journal"
            Exit Sub
        End If
    Else
        Open CFN For Output As #1
        Print #1, "0" : Print #1, "0"
        For i = 1 To UBound(W)
            Print #1, $Delimiter + Trim$(W(i).date) + $Delimiter + Trim$(W(i).Author) + $Delimiter + Trim$(W(i).Key) + $Delimiter
            Print #1, Trim$(W(i).words)
        Next i
        Close #1
    End If

    Changes = 0
End Sub

Sub ShowBlog(i As Long)
    If Debug Then cPrint LCase$(FuncName$)
    Control Set Text hDlg, %IDC_Date, Trim$(W(i).date)
    Control Set Text hDlg, %IDC_Label, Trim$(W(i).date)
    Control Set Text hDlg, %IDC_Author, Trim$(W(i).author)
    Control Set Text hDlg, %IDC_Key, Trim$(W(i).key)
    Control Set Text hDlg, %IDC_Words, Trim$(W(i).Words)
End Sub

Sub ShowAllBlogs
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long, temp$, P As CharRange

    Control Set Text hDlg, %IDC_RichEdit, ""
    ListBox Reset hDlg, %IDC_ListBox
    For i = maxBlogs To 1 Step - 1
        'RichEdit
        temp$ = Trim$(W(i).date)
        temp$ = temp$ + $CrLf + Trim$(W(i).author)
        temp$ = temp$ + $CrLf + Trim$(W(i).key) + $CrLf + $CrLf
        SendMessage hRichEdit, %EM_SetBkgndColor, 0, %Blue
        setRichTextColor %Black
        P.cpmin = 100000 : P.cpmax = 100000
        SendMessage(hRichEdit, %EM_ReplaceSel, %True, StrPtr(temp$))   'only replace if selection exists.
        SendMessage(hRichEdit, %EM_EXSetSel, 0, VarPtr(P))

        'set bgcolor to white
        temp$ = Trim$(W(i).words) + $CrLf + $CrLf
        SendMessage hRichEdit, %EM_SetBkgndColor, 0, %White
        setRichTextColor %Blue
        P.cpmin = 100000 : P.cpmax = 100000
        SendMessage(hRichEdit, %EM_ReplaceSel, %True, StrPtr(temp$))   'only replace if selection exists.
        SendMessage(hRichEdit, %EM_EXSetSel, 0, VarPtr(P))

        'ListBox
        ListBox Add hDlg, %IDC_ListBox, Trim$(W(i).date)
        ListBox Select hDlg, %IDC_ListBox, UBound(W) - curBlog + 1
    Next i
End Sub

Function setRichTextColor( ByVal NewColor As Long) As Long
    If Debug Then cPrint LCase$(FuncName$)
  Local cf As CharFormat
  cf.cbSize      = Len(cf)       'Length of structure
  cf.dwMask      = %CFM_Color    'Set mask to colors only
  cf.crTextColor = NewColor      'Set the new color value
  SendMessage(hRichEdit, %EM_SetCharFormat, %SCF_Selection, VarPtr(cf))
End Function

Sub UpdateCurrentBlog
    If Debug Then cPrint LCase$(FuncName$)
   Control Get Text hDlg, %IDC_Date To W(curBlog).date
   Control Get Text hDlg, %IDC_Author To W(curBlog).author
   Control Get Text hDlg, %IDC_Key To W(curBlog).key
   Control Get Text hDlg, %IDC_Words To W(curBlog).words
End Sub

Sub CreateToolbar
    If Debug Then cPrint LCase$(FuncName$)
    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0    'attach imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_NewJournal,  %TbStyle_Button, "New"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_Open,  %TbStyle_Button, "Open"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Save,  %TbStyle_Button Or %TbStyle_DropDown, "Save"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDT_Previous,  %TbStyle_Button, "Previous"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 17, %IDT_NewBlog,  %TbStyle_Button Or %TbStyle_DropDown, "New"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 15, %IDT_Delete,  %TbStyle_Button, "Delete"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 14, %IDT_Next,  %TbStyle_Button, "Next"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 19, %IDT_Search,  %TbStyle_Button, "Search"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 16, %IDT_Encrypt,  %TbStyle_Check, "Encrypt"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 18, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Help,  %TbStyle_Button Or %TbStyle_DropDown, "Help"

    Menu New PopUp To hPopupSave
    Menu Add String, hPopupSave, "Save As ...", %IDM_SaveAs, %MF_Enabled

    Menu New PopUp To hPopupHelp
    Menu Add String, hPopupHelp, "About", %IDM_About, %MF_Enabled

    Menu New PopUp To hPopupDate
    Menu Add String, hPopupDate, "Select Date ...", %IDM_SelectDate, %MF_Enabled

    Menu New PopUp To hPopupSettings
    Menu Add String, hPopupSettings, "Sort Ascending", %IDM_SortAscending, %MF_Enabled
    Menu Add String, hPopupSettings, "Sort Descending", %IDM_SortDescending, %MF_Enabled
    Menu Add String, hPopupSettings, "-",               %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopupSettings, "Select Caption Color", %IDM_LabelColor, %MF_Enabled
    Menu Add String, hPopupSettings, "-",               %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopupSettings, "Confirm Delete", %IDM_ConfirmDelete, %MF_Enabled
    Menu Add String, hPopupSettings, "AutoSave", %IDM_AutoSave, %MF_Enabled
End Sub

Sub CreateImageList
    If Debug Then cPrint LCase$(FuncName$)
    ImageList New Icon 24,24,24,20 To hImageList
    ImageList Add Icon hImageList, "xcreate"      '1
    ImageList Add Icon hImageList, "xfonts"       '2
    ImageList Add Icon hImageList, "xcolors"      '3
    ImageList Add Icon hImageList, "xhelp"        '4
    ImageList Add Icon hImageList, "xsettings"    '5
    ImageList Add Icon hImageList, "xsave"        '6
    ImageList Add Icon hImageList, "xopen"        '7
    ImageList Add Icon hImageList, "xnew"         '8
    ImageList Add Icon hImageList, "xwords"       '9
    ImageList Add Icon hImageList, "ximage"       '10
    ImageList Add Icon hImageList, "xpatterns"    '11
    ImageList Add Icon hImageList, "xlock"        '12
    ImageList Add Icon hImageList, "xprevious"    '13
    ImageList Add Icon hImageList, "xnext"        '14
    ImageList Add Icon hImageList, "xdelete"      '15
    ImageList Add Icon hImageList, "xencrypt"     '16
    ImageList Add Icon hImageList, "xnewdate"     '17
    ImageList Add Icon hImageList, "xsettings"    '18
    ImageList Add Icon hImageList, "xsearch"      '19
End Sub

Sub Settings_INI(Task$)
    If Debug Then cPrint LCase$(FuncName$)
   Local i,x,y As Long
   Local xResult, yResult, tempz, INIFileName As AsciiZ * %Max_Path

   'set ini filename
   INIFileName = Exe.Path$ + "gbjournal.ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "400", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "400", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "560", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "480", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      'get value for string variables
      GetPrivateProfileString "All", "CFN", Exe.Path$ + "gbjournal_default.dat", tempz, %Max_Path, INIFileName
      CFN = LCase$(tempz)

      GetPrivateProfileString "All", "SearchTerm", "", tempz, %Max_Path, INIFileName
      SearchTerm = LCase$(tempz)

      'get value for numeric variables
      Getprivateprofilestring "All", "ConfirmDelete", "1", tempz, %Max_Path, INIFileName
      ConfirmDelete = Val(tempz)
      Menu Set State hPopupSettings, ByCmd %IDM_ConfirmDelete, ConfirmDelete * 8

      Getprivateprofilestring "All", "Encrypt", "0", tempz, %Max_Path, INIFileName
      Encrypt = Val(tempz)
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Encrypt, %TBState_Checked * Encrypt Or %TBState_Enabled

      Getprivateprofilestring "All", "AutoSave", "1", tempz, %Max_Path, INIFileName
      AutoSave = Val(tempz)
      Menu Set State hPopupSettings, ByCmd %IDM_AutoSave, AutoSave * 8

      Getprivateprofilestring "All", "NewJournalCount", "0", tempz, %Max_Path, INIFileName
      NewJournalCount = Val(tempz)

      Getprivateprofilestring "All", "Debug", "0", tempz, %Max_Path, INIFileName
      Debug = Val(tempz)

      Getprivateprofilestring "All", "LabelColor", Str$(%rgb_LightBlue), tempz, %Max_Path, INIFileName
      LabelColor = Val(tempz)

      For i = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(i,"00"), "", tempz, %Max_Path, INIFileName
         CustomColorList.c(i) = Val(tempz)
      Next i

   End If

   If Task$ = "save" Then
      If Len(Dir$(INIFileName)) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "CFN", (CFN), INIFileName
      WritePrivateProfileString "All", "SearchTerm", (SearchTerm), INIFileName
'      'save numeric variable
      WritePrivateProfileString "All", "ConfirmDelete", (Str$(ConfirmDelete)), INIFileName
      WritePrivateProfileString "All", "Encrypt", (Str$(Encrypt)), INIFileName
      WritePrivateProfileString "All", "AutoSave", (Str$(AutoSave)), INIFileName
      WritePrivateProfileString "All", "NewJournalCount", (Str$(NewJournalCount)), INIFileName
      WritePrivateProfileString "All", "Debug", (Str$(Debug)), INIFileName
      WritePrivateProfileString "All", "LabelColor", (Str$(LabelColor)), INIFileName

      For i = 0 To 15
         tempz = Str$(CustomColorList.c(i))
         WritePrivateProfileString "Custom", "CustomColor" + Format$(i,"00"), tempz, INIFileName
      Next i

   End If
End Sub

Sub ShowCalendarDialog()
    If Debug Then cPrint LCase$(FuncName$)
   Local pt As Point
   GetCursorPos pt
   ScreenToClient hDlg, pt
   OneOnly = 1
   Dialog New Pixels, hDlg, "Select Date", pt.x, pt.y, 180, 155, %WS_SysMenu To hCalDialog
   Control Add "SysMonthCal32", hCalDialog, %IDC_Calendar, "Test", 0,0, 180,155, %WS_Child Or %WS_Visible
   Control Handle hCalDialog, %IDC_Calendar To hCalendar
   Dialog Show Modal hCalDialog Call CalProc()
End Sub

CallBack Function CalProc() As Long
    If Debug Then cPrint LCase$(FuncName$)
   Local iResult As Long
   Select Case Cb.Msg
      Case %WM_Destroy
         OneOnly = 0
      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDC_Calendar
               Select Case Cb.NmCode
                  Case %MCN_Select
                     iResult = DateTime_GetSystemtime(hCalendar, DT)
                     CalendarDate = Str$(DT.wmonth) + "-" + Str$(DT.wday) + "-" +Str$(DT.wyear)
                     Dialog End hCalDialog
               End Select
         End Select
   End Select
End Function

Function InstanceTest() As Long
    If Debug Then cPrint LCase$(FuncName$)
   'returns 0 if instance exits or cannot create mutex. otherwise returns 1.
   Local UniqueName As AsciiZ * %Max_Path
   UniqueName = "gbJournal"
   If CreateMutex(ByVal %Null, 0, UniqueName) = 0 _
         Or GetLastError = %ERROR_ALREADY_EXISTS Then Exit Function Else Function = 1
End Function

Function SelectCFN() As Long
    If Debug Then cPrint LCase$(FuncName$)
   Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
   title$ = "Open Journal"
   filter$ = "Journal Data (*.dat)" + $Nul + "*.dat" + $Nul
   startfolder$ = CFN
   startfile$ = CFN
   defaultext$ = "dat"
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
   If Len(filevar$) Then CFN = filevar$ : Dialog Set Text hDlg, "gbJournal" + $ver + Space$(5) + CFN : Function = 1
End Function

Function SaveAs() As Long
    If Debug Then cPrint LCase$(FuncName$)
    'save file to any location
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""             'caption title. if "", then "Save As" is displayed
    startfolder$ = CFN   'initial folder to be displayed
    filter$ = "Journal Data (*.dat)" + $Nul + "*.dat" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfile$ = CFN        'name to be used as initial selection
    defaultext$ = "dat"     'default extension to append to selection if user does not enter it
    flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
    Display Savefile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then CFN = filevar$ : Dialog Set Text hDlg, "gbJournal" + $ver + Space$(5) + CFN : Function = 1
End Function

Function MsgBoxX(msg$,Flag As Long,caption$) As Long
    If Debug Then cPrint LCase$(FuncName$)
   hHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   Function = MessageBox( 0, (msg$), (caption$), Flag)
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
    If Debug Then cPrint LCase$(FuncName$)
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x,y,ww,hh As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To ww,hh
   CenterX = x + (ww-BoxX)/2
   CenterY = y + (hh-BoxY)/2
End Sub

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    If Debug Then cPrint LCase$(FuncName$)
   Local x As Long, y As Long    'MsgBoxX is approximately 200x200
   CenterOverDialog 370,170,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx hHook
   End If
End Function

Sub SortAscending
    If Debug Then cPrint LCase$(FuncName$)
    Array Sort W(1), Call SortA()
End Sub

Sub SortDescending
    If Debug Then cPrint LCase$(FuncName$)
    Array Sort W(1), Call SortD()
End Sub

Function SortA(A As Blog, B As Blog) As Long
    ' -1 if 1st should precede 2nd : +1 if 2nd should precede 2nd
    Function = IIf(A.date > B.date,-1,+1)
End Function

Function SortD(A As Blog, B As Blog) As Long
    ' -1 if 1st should precede 2nd : +1 if 2nd should precede 2nd
    Function = IIf(A.date < B.date,-1,+1)
End Function

Sub DeleteCurrentBlog
    If Debug Then cPrint LCase$(FuncName$)
   Array Delete W(curBlog)
   If curBlog > 1 Then Decr curBlog
   Decr MaxBlogs
   ReDim Preserve W(maxBlogs)
   ShowAllBlogs
   ShowBlog(curBlog)
   ListBox Select hDlg, %IDC_ListBox, UBound(W) - curBlog + 1
   Changes = 1
End Sub

Sub CreateFonts
    If Debug Then cPrint LCase$(FuncName$)
    Font New "Cooper", 18,1 To hFontLabel
    Font New "Consolas", 16,1 To hFontHeader
    Font New "Consolas", 12,0 To hFontBlog
End Sub

Sub SubClassControls
    If Debug Then cPrint LCase$(FuncName$)
   Control Handle hDlg, %IDC_Date To hDate
   Control Handle hDlg, %IDC_Author To hAuthor
   Control Handle hDlg, %IDC_Key To hKey
   Control Handle hDlg, %IDC_Words To hWords

   OldProcDate = SetWindowLong(GetDlgItem(hDlg, %IDC_Date), %GWL_WndProc, CodePtr(NewProcDate))  'subclass
   OldProcAuthor = SetWindowLong(GetDlgItem(hDlg, %IDC_Author), %GWL_WndProc, CodePtr(NewProcAuthor))  'subclass
   OldProcKey = SetWindowLong(GetDlgItem(hDlg, %IDC_Key), %GWL_WndProc, CodePtr(NewProcKey))  'subclass
   OldProcWords = SetWindowLong(GetDlgItem(hDlg, %IDC_Words), %GWL_WndProc, CodePtr(NewProcWords))  'subclass

   Menu New PopUp To hContextDate
   Menu Add String, hContextDate, "Cut",  %IDM_CutDate,  %MF_Enabled
   Menu Add String, hContextDate, "Copy",  %IDM_CopyDate,  %MF_Enabled
   Menu Add String, hContextDate, "Paste",  %IDM_PasteDate,  %MF_Enabled
   Menu Add String, hContextDate, "Delete", %IDM_DeleteDate,  %MF_Enabled

   Menu New PopUp To hContextAuthor
   Menu Add String, hContextAuthor, "Cut",  %IDM_CutAuthor,  %MF_Enabled
   Menu Add String, hContextAuthor, "Copy",  %IDM_CopyAuthor,  %MF_Enabled
   Menu Add String, hContextAuthor, "Paste",  %IDM_PasteAuthor,  %MF_Enabled
   Menu Add String, hContextAuthor, "Delete", %IDM_DeleteAuthor,  %MF_Enabled

   Menu New PopUp To hContextKey
   Menu Add String, hContextKey, "Cut",  %IDM_CutKey,  %MF_Enabled
   Menu Add String, hContextKey, "Copy",  %IDM_CopyKey,  %MF_Enabled
   Menu Add String, hContextKey, "Paste",  %IDM_PasteKey,  %MF_Enabled
   Menu Add String, hContextKey, "Delete", %IDM_DeleteKey,  %MF_Enabled

   Menu New PopUp To hContextWords
   Menu Add String, hContextWords, "Cut",  %IDM_CutWords,  %MF_Enabled
   Menu Add String, hContextWords, "Copy",  %IDM_CopyWords,  %MF_Enabled
   Menu Add String, hContextWords, "Paste",  %IDM_PasteWords,  %MF_Enabled
   Menu Add String, hContextWOrds, "Delete", %IDM_DeleteWords,  %MF_Enabled
End Sub

Function NewProcDate(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   If Debug Then cPrint LCase$(FuncName$)
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextDate, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProcDate, hWnd, Msg, wParam, lParam)
End Function

Function NewProcAuthor(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   If Debug Then cPrint LCase$(FuncName$)
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextAuthor, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProcDate, hWnd, Msg, wParam, lParam)
End Function

Function NewProcKey(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   If Debug Then cPrint LCase$(FuncName$)
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextKey, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProcDate, hWnd, Msg, wParam, lParam)
End Function

Function NewProcWords(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   If Debug Then cPrint LCase$(FuncName$)
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextWords, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProcWords, hWnd, Msg, wParam, lParam)
End Function

Function EncryptData(text$, password$) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local i As Long, a As Long, temp$
   If Len(Password$) = 0 Then Function = text$ : Exit Function
   For i = 1 To Len(text$)
         a = i Mod Len(password$)
         If a = 0 Then a = Len(password$)
         Mid$(temp$,i) = (Chr$(Asc(Mid$(password$,a,1)) Xor Asc(Mid$(text$,i,1))))
   Next i
   Function = temp$
? temp$
End Function

Function ValidatePassword(fName$) As Long
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$, x,y,iResult As Long
    Open fName$ For Input As #1
    Line Input #1, temp$
    If Val(temp$) Then
        'password required
        Line Input #1, temp$
        Close #1
        CenterOverDialog(300,225,x,y)
        While iResult < 2
            psw = InputBox$(IIf$(iResult,"Wrong password. Re-Enter password:","Enter password:"), "<None>","Password",x,y)
            If psw = "" Then Exit Function
            If EncryptData(temp$,psw) <> "Success" Then
                iResult = 1 : Beep
            Else
                iResult = 2
            End If
        Wend
        Function = 1
    Else
        'no password required
        Function = 1
    End If
    Close #1
End Function

Function EnterPassword() As String
    If Debug Then cPrint LCase$(FuncName$)
    Local x,y As Long
    CenterOverDialog(300,225,x,y)
    Function = InputBox$("Enter password:", psw, "Password",x,y)
End Function

Function CreateNewJournal() As String
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$
    Incr NewJournalCount
    temp$ = Exe.Path$ + "gbjournal_" + Format$(NewJournalCount,"000") + ".dat"
    Open temp$ For Output As #1
    Print #1, "0"
    Print #1, "0"
    Print #1, $Delimiter + Date$ + $Delimiter + "<empty>" + $Delimiter + "<empty>"
    Print #1, "<empty>"
    Close #1
    Function = temp$
End Function

Sub CPrint (SOut As String)
    'Debug left off by intent
   Static cWritten As Long, iMsgCount As Long
   Incr iMsgCount
   SOut = Str$(iMsgCount) + " " + SOut
   If hConsole = 0 Then AllocConsole: hConsole = GetStdHandle(-11&)
   WriteConsole hConsole, ByCopy sOut + $CrLf, Len(sOut) + 2, cWritten, ByVal 0&
End Sub

Sub BuildAcceleratorTable
   If Debug Then cPrint LCase$(FuncName$)
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(4)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1     : ac(c).cmd   = %IDT_Help              : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3     : ac(c).cmd   = %IDM_Search            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D      : ac(c).cmd   = %IDM_Debug             : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E      : ac(c).cmd   = %IDM_ClearConsole      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F      : ac(c).cmd   = %IDM_Search            : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub ClearConsole
   If Debug Then cPrint LCase$(FuncName$)
   Local hWrittenChars As Long, tConsoleInfo As CONSOLE_SCREEN_BUFFER_INFO
   GetConsoleScreenBufferInfo(hConsole, tConsoleInfo)
   FillConsoleOutputCharacter(hConsole, 32, tConsoleInfo.dwSize.x * tConsoleInfo.dwSize.y, Mak(Dword,0,0), hWrittenChars)
   SetConsoleCursorPosition(hConsole, Mak(Dword,0,0))
   Sleep 500   'time for cursor to move off ListView
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   If Debug Then cPrint LCase$(FuncName$)
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub DisplayFindDialog()
     Dialog New Pixels, hDlg, "Find Text", 70, 100, 270, 45, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hSearch
     Dialog Set Icon hSearch, "xsearch"
     Control Add Label, hSearch, %IDC_SearchLabel, "Find This:", 5, 10, 50, 20
     Control Add TextBox, hSearch, %IDC_SearchTerm, SearchTerm, 60, 10, 100, 20
     Control Add Button, hSearch, %IDC_SearchNext, "Next", 170, 10, 40, 25
     Control Add Button, hSearch, %IDC_SearchPrevious, "Prev", 220, 10, 40, 25
     fDlgShown = 1
     Dialog Show Modeless hSearch Call SearchProc()
     Do                                                                    'because we want to be able
        Dialog DoEvents                                                     'to edit main text while
     Loop Until fDlgShown = 0
End Sub

CallBack Function SearchProc() As Long
    Select Case Cb.Msg
      Case %WM_SYSCOMMAND
         If (Cb.WParam And &HFFF0) = %SC_Close Then          'trap Alt-F4 and X Button
            Control Set Focus hDlg, %IDC_Words
         End If
      Case %WM_Destroy
         fDlgShown = 0
       Case %WM_Command
          Select Case Cb.Ctl
             Case %IdCancel
                 fDlgShown = 0
                 Dialog End hSearch
             Case %IDC_SearchNext, %IdOk    'search forward
                Control Get Text hSearch, %IDC_SearchTerm To SearchTerm
                FindTextInRichEdit 1                    '1 means forward search
             Case %IDC_SearchPrevious    'search backward
                Control Get Text hSearch, %IDC_SearchTerm To SearchTerm
                FindTextInRichEdit 0                    '0 means backward seasrch
          End Select
    End Select
End Function


Sub FindTextinRichEdit(iDirection&)  'SearchTerm$, SearchStart& are global
   Local temp$, P As CharRange, sTerm$
   Control Get Text hDlg, %IDC_RichEdit To temp$                   'get text from RichEdit
   Control Send hDlg, %IDC_RichEdit, %EM_ExGetSel, 0, VarPtr(P)    'get caret/selection boundaries

   sTerm$ = LCase$(SearchTerm)
   temp$ = LCase$(temp$)

   If iDirection& Then
      SearchStart = InStr(P.cpMax+1, temp$, sTerm$)
   Else
      SearchStart = InStr(-1*(Len(temp$)-P.cpMin), temp$, sTerm$)
   End If

   If SearchStart Then
      P.cpMin = SearchStart - 1
      P.cpMax = SearchStart + Len(sTerm$) - 1
      Control Send hDlg, %IDC_RichEdit, %EM_ExSetSel, 0, VarPtr(P)
   Else
      Beep
   End If
End Sub
